<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		a, a:hover {
			background: transparent;
			border-bottom: 1px dotted #666;
			color: #666;
			text-decoration: none;		
		}

		a:hover {
			border: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Filesystem Utility</h1>

		<p>This utility is loaded using the following piece of code.</p>

		<div class="example">
			$this->load->utility('filesystem');
		</div>
	</div>

	<div class="content">
		<h1>read_file('path')</h1>

		<p>This function returns the data contained in the file specified in the path.</p>

		<div class="example">
			$string = read_file('./path/to/the/file.php');
		</div>

		<p>The path can either be a relative path or full serve rpath.  The function returns false on failure.</p>

		<p>The path is relative to the sites index.php file, not your controller or view files.</p>

		<p>If your server is running an open_basedir restriction this function may not work if you're trying to access
		a file above the calling script.</p>
	</div>

	<div class="content">
		<h1>write_file('path', $data)</h1>

		<p>This function writes data to the file specified in the path.  If the file does not exist the function will
		create it.</p>

		<div class="example">
			$data = 'This is some data for the file.';<br />
			<br />
			if (!write_file('./path/to/file.php', $data))<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo 'Unable to write data to the file.';<br />
			&#125;<br />
			else<br />
			&#123;<br />
			&nbsp;&nbsp;&nbsp;&nbsp;echo 'File has been written.';<br />
			&#125;
		</div>

		<p>You can also optionally set the write mode via the third parameter.</p>

		<div class="example">
			write_file('./path/to/file.php', $data, 'r+');
		</div>

		<p>The default mode is <b>wb</b>.  Please see the PHP documentation for the <b>fopen()</b> function.  In
		order for this function to write data to a file its file permissions must be set such that it is writable
		(666, or 777 should be enough).  If the file does not exist, the directory containing it must be writable.</p>

		<p>The path is relative to the sites index.php, not the controller or view files.</p>
	</div>

	<div class="content">
		<h1>delete_files('path')</h1>

		<p>Deletes all the file contained the directory supplied as the path.</p>

		<div class="example">
			delete_files('./path/to/dir');
		</div>

		<p>If the second parameter is set to <b>true</b>, any directories in the root of the path will be deleted
		as well.</p>

		<div class="example">
			delete_files('./path/to/dir', true);
		</div>

		<p>The files must be writable or owned by the system in order for them to be deleted.</p>
	</div>

	<div class="content">
		<h1>get_filenames('path')</h1>

		<p>Takes a server path as input and returns an array containing the names of all the files contained in the
		directory specified by the path.  The file path can optionally be added to the file name by passing
		<b>true</b> as the second parameter.</p>
	</div>
</body>

</html>
